#import "stdlib.ex4"
   string ErrorDescription(int a0);
#import 
//=========================================================================================================================================
extern string  set1              = "general EA settings";
extern int     MagicNumber       = 88888;
extern int     SlippagePips      = 3;
extern int     MaxSpreadPips     = 3;
extern string  TypeAutoCloseInfo = "0:Not Use, 1:If cross middle line, 2:If cross side line, 3:If corss opposite line";
extern int     TypeAutoClose     = 3;
extern int     MaxOpenedOrders   = 3;

extern string  set2              = "money management type: 1-fix lot, 2-fix pct, 3-fix amount";
extern int     mmType            = 3;
extern double  mmSize            = 5.0;
extern double  TLstep            = 1.0;
extern double  tpmfactor         = 1.5;
extern double  slmfactor         = 1.0;
extern string  set3              = "indicator settings";
extern int     Keltner_MA        = 20;
extern int     Keltner_ATR       = 20;
extern double  Keltner_k         = 2.0;
extern double  Trigger           = 20.0;
extern bool    Gapfilter           = true;
extern double  Gapsize           = 10;

//=========================================================================================================================================
int            bars = 0; 
uint           StartTimer;
double         UsePoint, SL, PT, SLpips, TLpips;
bool NomoreBuytrade,NomoreSelltrade;
//=========================================================================================================================================
int init() 
   {
      if (Digits <= 3) UsePoint = 0.01;
      else UsePoint = 0.0001;
      if((TypeAutoClose<0)||(TypeAutoClose>3)) TypeAutoClose=0;
      return(INIT_SUCCEEDED);
   }
//=========================================================================================================================================
void start() 
   {   
   int BuyOrder=0; 
   int SellOrder=0; 
      // handle existing trade
      for (int i = 0; i < OrdersTotal(); i++) 
         {
            if((OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == TRUE) && (OrderSymbol() == Symbol()) && (OrderMagicNumber() == MagicNumber))
            {
            if(OrderType()==OP_BUY) BuyOrder++;
            if(OrderType()==OP_SELL) SellOrder++;
            if(TLpips > 0) TrialingSL(OrderTicket());
            }
         }
      //---------------------------------------------------------------------------------------------------------------
      //Close ordres
      double UpperLine0=iCustom(NULL, 0, "Keltner_Chanel", Keltner_MA , Keltner_ATR, Keltner_k, 0, 0);
      double UpperLine=iCustom(NULL, 0, "Keltner_Chanel", Keltner_MA , Keltner_ATR, Keltner_k, 0, 1);
      double LowerLine0=iCustom(NULL, 0, "Keltner_Chanel", Keltner_MA , Keltner_ATR, Keltner_k, 1, 0);
      double LowerLine=iCustom(NULL, 0, "Keltner_Chanel", Keltner_MA , Keltner_ATR, Keltner_k, 1, 1);
      double MiddleLine=iCustom(NULL, 0, "Keltner_Chanel", Keltner_MA , Keltner_ATR, Keltner_k, 2, 1);
      //---------------------------------------------------------------------------------------------------------------
      ///extern string  TypeAutoCloseInfo = "1:If cross middle line, 2:If cross side line, 3:If corss opposite line";
      ///extern int     TypeAutoClose     = 1;
      //---------------------------------------------------------------------------------------------------------------
      if(TypeAutoClose==1)
      {
      if((BuyOrder>0)&&(Bid<MiddleLine)) CloseOrderAtMarket(OP_BUY);
      if((SellOrder>0)&&(Ask>MiddleLine)) CloseOrderAtMarket(OP_SELL);
      }
      //---
      if(TypeAutoClose==2)
      {
      if((BuyOrder>0)&&(Bid<UpperLine)) CloseOrderAtMarket(OP_BUY);
      if((SellOrder>0)&&(Ask>LowerLine)) CloseOrderAtMarket(OP_SELL);
      }
      //---
      if(TypeAutoClose==3)
      {
      if((BuyOrder>0)&&(Bid<LowerLine)) CloseOrderAtMarket(OP_BUY);
      if((SellOrder>0)&&(Ask>UpperLine)) CloseOrderAtMarket(OP_SELL);
      }
      //---------------------------------------------------------------------------------------------------------------
      // open new trade on bar open
      if (Bars > bars &&
          (Ask - Bid) / UsePoint <= MaxSpreadPips) 
            {
               bars = Bars;
               
               // *** TRADING LOGIC ***
               
                  // ENTRY: previous bar close is XX (=Trigger) pips above/below upper/lower Keltner band
                  // SL for long/short is the upper/lower Keltner band
                  // PT for both long and short the distance in pips to XX EMA (Keltner middle line)
                  // EXIT: via trialing SL wit 1 pip step 
                  
                  bool GOLONG = (Close[1] - UpperLine) / UsePoint > Trigger;
                  bool GOSHORT = (LowerLine - Close[1]) / UsePoint > Trigger;
                  
                  
                  
                  if ( Close[1] < MiddleLine  )NomoreBuytrade=false;
                  if (Close[1] > MiddleLine ) NomoreSelltrade=false;  
              
               // *********************
               SLpips = NormalizeDouble((UpperLine0-LowerLine0)/UsePoint, 1);
               int Ticket=0;
                 if (BuyOrder==MaxOpenedOrders||(GOLONG&&Gapfilter&&(Open[1]-Close[2]>(Gapsize*UsePoint)  )))  NomoreBuytrade =true;
                 if (SellOrder==MaxOpenedOrders||(GOSHORT&&Gapfilter&&(Close[2]-Open[1]>(Gapsize*UsePoint) )))  NomoreSelltrade =true;
                
               if(BuyOrder+SellOrder<MaxOpenedOrders )
               
               {
               if(GOLONG == TRUE && !NomoreBuytrade ) 
                  {
                           
                           SL = Bid - (SLpips*UsePoint*slmfactor);
                           TLpips = SLpips;
                           double tppips =(SLpips*UsePoint*tpmfactor);
                          
                           PT = NormalizeDouble(Bid +tppips , Digits);
                     //---
                     Ticket = OpenOrderAtMarket(GetLotSize(), OP_BUY);
                     if(OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES) == TRUE) ModifySLPT(Ticket, SL, PT);                                    
                  }
                     
               if(GOSHORT == TRUE && !NomoreSelltrade) 
                  {
                           
                           SL = Bid+ (SLpips*UsePoint*slmfactor);
                           TLpips = SLpips;
                           PT = NormalizeDouble((Bid -(SLpips*UsePoint*tpmfactor)), Digits);
                     //---
                     Ticket = OpenOrderAtMarket(GetLotSize(), OP_SELL);
                     if(OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES) == TRUE) ModifySLPT(Ticket, SL, PT);                                    
                   }
                }
                 
            }
             Comment("Channel width:",SLpips,"/Trigger",Trigger);
   }
//=========================================================================================================================================
int OpenOrderAtMarket(double argLotSize, int argDirection)
   {
      string DirectionDesc;
      color Color;
      double TradePrice;
      
      while(IsTradeContextBusy()) Sleep(10);
      
      if (argDirection == OP_BUY)
         {
            Color = clrBlue;
            DirectionDesc = "BUY";
            TradePrice = Ask;
         }

      if (argDirection == OP_SELL)
         {
            Color = clrRed;
            DirectionDesc = "SELL";
            TradePrice = Bid;
         }

      StartTimer = GetTickCount();
      int Ticket = OrderSend(Symbol(), argDirection, argLotSize, TradePrice, SlippagePips, 0, 0, NULL, MagicNumber, 0, Color);
      Print("open #", Ticket, " executed in ", GetTickCount() - StartTimer, " ms");

      if(Ticket <= 0) 
         {
            PrintError(StringConcatenate("UNABLE TO OPEN ", DirectionDesc, " ORDER"));
            return(0);
         }
      else 
         {
            if(OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES) == TRUE) Print("open #", Ticket, " spread: ", (Ask - Bid) / UsePoint, " slippage: ", CalcSlippage(1, argDirection, TradePrice, OrderOpenPrice()), " commision: ", OrderCommission());
            return(Ticket);
         }
   }
//=========================================================================================================================================
void CloseOrderAtMarket(int TypeClose)
   {
   for(int i=OrdersTotal()-1; i>=0; i--)
   {
   if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) continue;
   if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
   {
   if((OrderMagicNumber()!=MagicNumber)||(OrderSymbol()!=Symbol())) continue;
   if((OrderMagicNumber()==MagicNumber)&&(OrderSymbol()==Symbol()))
         {            
            while(IsTradeContextBusy()) Sleep(10);
            double TradePrice;
            int Ticket = 0;
            if((OrderType() == OP_BUY)&&(TypeClose==OP_BUY))
            {
            StartTimer = GetTickCount();
            Ticket = OrderClose(OrderTicket(), OrderLots(), Bid, SlippagePips, clrNONE);
            if (Ticket > 0)  Print("close #", OrderTicket(), " executed in ", GetTickCount()-StartTimer, " ms");
            if (Ticket <= 0)  PrintError(StringConcatenate("UNABLE TO CLOSE ORDER #", OrderTicket()));
            else Print("close_stats #", OrderTicket(), " spread: ", (Ask - Bid) / UsePoint, " slippage: ", CalcSlippage(0, OrderType(), TradePrice, OrderClosePrice()), " commision: ", OrderCommission());
            }
            if((OrderType() == OP_SELL)&&(TypeClose==OP_SELL))
            {
            StartTimer = GetTickCount();
            Ticket = OrderClose(OrderTicket(), OrderLots(), Ask, SlippagePips, clrNONE);
            if (Ticket > 0)  Print("close #", OrderTicket(), " executed in ", GetTickCount()-StartTimer, " ms");
            if (Ticket <= 0)  PrintError(StringConcatenate("UNABLE TO CLOSE ORDER #", OrderTicket()));
            else Print("close_stats #", OrderTicket(), " spread: ", (Ask - Bid) / UsePoint, " slippage: ", CalcSlippage(0, OrderType(), TradePrice, OrderClosePrice()), " commision: ", OrderCommission());
            }

         }
   }
   }
   }
//=========================================================================================================================================
void ModifySLPT(int argTicket, double argSL, double argPT)
   {
      double StopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL) * Point;

      if (OrderSelect(argTicket, SELECT_BY_TICKET, MODE_TRADES) == TRUE)
         {
            if (argSL != 0)
               {
                  if (OrderType() == OP_BUY && argSL > (Bid-StopLevel)) argSL = NormalizeDouble(Bid-StopLevel, Digits);
                  if (OrderType() == OP_SELL && argSL < (Ask+StopLevel)) argSL = NormalizeDouble(Ask+StopLevel, Digits);
               }

            if (argPT != 0)
               {
                  if (OrderType() == OP_BUY && argPT < (Bid+StopLevel)) argPT = NormalizeDouble(Bid+StopLevel, Digits);
                  if (OrderType() == OP_SELL && argPT > (Ask-StopLevel)) argPT = NormalizeDouble(Ask-StopLevel, Digits);
               }

            while(IsTradeContextBusy()) Sleep(10);

            StartTimer = GetTickCount();
            int Ticket = OrderModify(argTicket, OrderOpenPrice(), argSL, argPT, 0, clrNONE);
            Print("modify #", argTicket, " executed in ", GetTickCount() - StartTimer, " ms");
                  
            if(Ticket <= 0) PrintError(StringConcatenate("UNABLE TO CHANGE SL/PT for ticket #", argTicket));
         }
   }
//=========================================================================================================================================
void TrialingSL(int argTicket)
   {
      double newSL;
      
      if (OrderSelect(argTicket, SELECT_BY_TICKET, MODE_TRADES) == TRUE)
         {
            if (OrderType() == OP_BUY)
               {
                  newSL = NormalizeDouble(Bid - TLpips * UsePoint, Digits);
                  if((newSL-OrderStopLoss()) / UsePoint >= TLstep) ModifySLPT(argTicket, newSL, OrderTakeProfit());
               }
            if (OrderType() == OP_SELL)
               {
                  newSL = NormalizeDouble(Ask + TLpips * UsePoint, Digits);
                  if((OrderStopLoss()-newSL) / UsePoint >= TLstep) ModifySLPT(argTicket, newSL, OrderTakeProfit());
               }
         }
   }
//=========================================================================================================================================
double GetLotSize() 
   {
      double lotMM;
      double mMinLot = MarketInfo(Symbol(), MODE_MINLOT);
      double mMaxLot = MarketInfo(Symbol(), MODE_MAXLOT);
      double mLotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
      double mLotSize = MarketInfo(Symbol(), MODE_LOTSIZE);
      double CurrencyAdjuster = 1;
      
      if (MarketInfo(Symbol(), MODE_TICKSIZE) != 0) CurrencyAdjuster = MarketInfo(Symbol(), MODE_TICKVALUE) * (MarketInfo(Symbol(), MODE_POINT) / MarketInfo(Symbol(), MODE_TICKSIZE));

      if(mmType == 1) lotMM = mmSize;
      if(mmType == 2) lotMM = (AccountBalance() * (mmSize / 100.0)) / CurrencyAdjuster / (SLpips * 10.0);
      if(mmType == 3) lotMM = (AccountBalance()/MarketInfo(Symbol(),MODE_LOTSIZE))*mmSize;

      if(mLotSize == 10000.0) lotMM = lotMM * 10.0 ;
      lotMM = NormalizeDouble(lotMM, 2);

      if (lotMM < mMinLot) lotMM = mMinLot;
      if (lotMM > mMaxLot) lotMM = mMaxLot;

      return (lotMM);
   }
//=========================================================================================================================================
double CalcSlippage(int argTrade, int argDirection, double pxRequested, double pxTraded)
   {
      switch(argTrade)
         {
            case 1:  // open
               if(argDirection == OP_BUY) return((pxRequested-pxTraded)/UsePoint);
               if(argDirection == OP_SELL) return((pxTraded-pxRequested)/UsePoint);
            case 0:  // close
               if(argDirection == OP_BUY) return((pxTraded-pxRequested)/UsePoint);
               if(argDirection == OP_SELL) return((pxRequested-pxTraded)/UsePoint);
            default:
               return(0);            
         }
   }
//=========================================================================================================================================
void PrintError(string comment)
   {
      int ErrorCode = GetLastError();
      string ErrDesc = ErrorDescription(ErrorCode);
      Print(comment, " / ErrorCode: ", ErrorCode," / Error Description: ", ErrDesc);
   }
//=========================================================================================================================================
